
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Team_member_skillsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const team_member_skills = await db.team_member_skills.create(
            {
                id: data.id || undefined,
        
        proficiency: data.proficiency
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await team_member_skills.setTenant( data.tenant || null, {
            transaction,
        });
        
        await team_member_skills.setTeam_member( data.team_member || null, {
            transaction,
        });
        
        await team_member_skills.setSkill( data.skill || null, {
            transaction,
        });
        
        await team_member_skills.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return team_member_skills;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const team_member_skillsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                proficiency: item.proficiency
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const team_member_skills = await db.team_member_skills.bulkCreate(team_member_skillsData, { transaction });

        // For each item created, replace relation files
        

        return team_member_skills;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const team_member_skills = await db.team_member_skills.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.proficiency !== undefined) updatePayload.proficiency = data.proficiency;
        
        
        updatePayload.updatedById = currentUser.id;

        await team_member_skills.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await team_member_skills.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.team_member !== undefined) {
            await team_member_skills.setTeam_member(
              
              data.team_member,
              
              { transaction }
            );
        }
        
        if (data.skill !== undefined) {
            await team_member_skills.setSkill(
              
              data.skill,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await team_member_skills.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return team_member_skills;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const team_member_skills = await db.team_member_skills.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (team_member_skills.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of team_member_skills) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of team_member_skills) {
                await record.destroy({transaction});
            }
        });


        return team_member_skills;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const team_member_skills = await db.team_member_skills.findByPk(id, options);

        if (!team_member_skills) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await team_member_skills.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await team_member_skills.destroy({
            transaction
        });

        return team_member_skills;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const team_member_skills = await db.team_member_skills.findOne(
            { where },
            { transaction },
        );

        if (!team_member_skills) {
            return team_member_skills;
        }

        const output = team_member_skills.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await team_member_skills.getTenant({
            transaction
        });
        
        
        output.team_member = await team_member_skills.getTeam_member({
            transaction
        });
        
        
        output.skill = await team_member_skills.getSkill({
            transaction
        });
        
        
        output.organizations = await team_member_skills.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.team_members,
        as: 'team_member',
        
        where: filter.team_member ? {
          [Op.or]: [
            { id: { [Op.in]: filter.team_member.split('|').map(term => Utils.uuid(term)) } },
            {
              notes: {
                [Op.or]: filter.team_member.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.skills,
        as: 'skill',
        
        where: filter.skill ? {
          [Op.or]: [
            { id: { [Op.in]: filter.skill.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.skill.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.proficiency) {
                where = {
                    ...where,
                proficiency: filter.proficiency,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.team_member_skills.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'team_member_skills',
                        'proficiency',
                        query,
                    ),
                ],
            };
        }

        const records = await db.team_member_skills.findAll({
            attributes: [ 'id', 'proficiency' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['proficiency', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.proficiency,
        }));
    }

    
};

